#version 330

uniform vec3 BrickColor = vec3(1.f, 0.3f, 0.2f);
uniform vec3 MortarColor = vec3(0.85f, 0.86f, 0.84f);
uniform vec2 BrickSize = vec2(0.3f, 0.15f);
uniform vec2 BrickPct = vec2(0.9f, 0.85f);

in vec4 localPos;

out vec4 outputF;

//----------------------------------------------------------------
// TODO:
// 1) Implement the brick patter in the xz plane.
// 2) Apply smoothstep.
// 3) Notice the difference in using texture (wallpaper) vs position (carving) coordinates.
//----------------------------------------------------------------

void main()
{
	vec2 position = localPos.xz / BrickSize;

	if(fract(position.y * 0.5f) > 0.5f)
		position.x += 0.5f;

	position = fract(position);

#if 1
	vec2 useBrick = step(position, BrickPct); // Changed order to inverse edge
#else
	vec2 useBrick = smoothstep(0.f, 0.1f, position) - smoothstep(BrickPct-0.05f, BrickPct+0.05f, position);
#endif

	vec3 color = mix(MortarColor, BrickColor, useBrick.x * useBrick.y);
	outputF = vec4(color, 1.f);
}