#version 330

uniform vec3 BrickColor = vec3(1.f, 0.3f, 0.2f);
uniform vec3 MortarColor = vec3(0.85f, 0.86f, 0.84f);
uniform vec3 BrickSize = vec3(0.3f, 0.15f, 0.15f);
uniform vec3 BrickPct = vec3(0.9f, 0.85f, 0.85f);

in vec4 localPos;

out vec4 outputF;

//----------------------------------------------------------------
// TODO:
// 1) Go to 3D.
// 2) Offset the position a little in the y-axis to have the caps shaded.
// 3) Is using texture (wallpaper) vs position (carving) coordinates different in 2D and 3D?
//----------------------------------------------------------------

void main()
{
#if 1
	vec3 position = localPos.xyz;
#else
	vec3 position = localPos.xyz + vec3(0.f, 0.5f, 0.f); // To have the caps shaded
#endif
	position /= BrickSize;

	if((fract(position.y * 0.5f) > 0.5f) != (fract(position.z * 0.5f) > 0.5f)) // XOR
		position.x += 0.5f;

	position = fract(position);

	vec3 useBrick = smoothstep(0.f, 0.02f, position) - smoothstep(BrickPct-0.01f, BrickPct+0.01f, position);

	vec3 color = mix(MortarColor, BrickColor, useBrick.x * useBrick.y * useBrick.z);
	outputF = vec4(color, 1.f);
}