#version 330

uniform vec4 color1 = vec4(0.0f, 0.0f, 1.0f, 1.0f);
uniform vec4 color2 = vec4(0.3f, 0.7f, 0.5f, 1.0f);

uniform int multiplicationFactor = 16;

in vec2 texCoordV;

out vec4 outputF;

//----------------------------------------------------------------
// TODO:
// 1) Compute how far the fragment is between the stripes in the s-axis (x-axis) using frac().
// 2) Mix color1 or color2 using the frac, apply smoothstep.
// 3) Vary the smoothstep width.
//----------------------------------------------------------------

void main()
{
	float f = fract(texCoordV.s * multiplicationFactor);
#if 0
	float s = smoothstep(0.4f, 0.5f, f) - smoothstep(0.9f, 1.f, f);
#else
	float s = smoothstep(0.45f, 0.5f, f) - smoothstep(0.95f, 1.f, f);
#endif;
	outputF = mix(color2, color1, s);
}